 mod = ...



-- Maps -------------------------------------------------------------------------------------
mod:registerAssetId("maps/heightmap.png", "HEIGHT_MAP")
mod:registerAssetId("maps/material_mask.png", "MATERIAL_MASK")
mod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")
mod:registerAssetId("maps/berries_density.png", "BERRIES_MAP")
mod:registerAssetId("maps/rock_density.png", "ROCK_MAP")
mod:registerAssetId("maps/tree_density_deciduous.png", "TREE_MAP_DECIDUOUS")
mod:registerAssetId("maps/tree_density_pine.png", "TREE_MAP_PINE")
mod:registerAssetId("maps/tree_density_palm.png", "TREE_MAP_PALM")
mod:registerAssetId("maps/well_density.png", "WELL_MAP")



-- Register custom map
mod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_ARCHIPELAGO",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -9,
	MaxHeight = 55,
	VillagePathList = {

        { Entrance = { 57, 0, 440 }, Exit = { 57, 0, 416 }, },
        { Entrance = { 57, 0, 439 }, Exit = { 57, 0, 415 }, },
        { Entrance = { 57, 0, 438 }, Exit = { 57, 0, 414 }, },
        { Entrance = { 57, 0, 437 }, Exit = { 57, 0, 413 }, },
        { Entrance = { 57, 0, 436 }, Exit = { 57, 0, 412 }, },
        { Entrance = { 57, 0, 435 }, Exit = { 57, 0, 411 }, },
        { Entrance = { 57, 0, 434 }, Exit = { 57, 0, 410 }, },
        { Entrance = { 57, 0, 433 }, Exit = { 57, 0, 409 }, },
        { Entrance = { 57, 0, 432 }, Exit = { 57, 0, 408 }, },
        { Entrance = { 57, 0, 431 }, Exit = { 57, 0, 407 }, },

        { Entrance = { 669, 0, 976 }, Exit = { 670, 0, 953 }, },
        { Entrance = { 669, 0, 975 }, Exit = { 670, 0, 952 }, },
        { Entrance = { 669, 0, 974 }, Exit = { 670, 0, 951 }, },
        { Entrance = { 669, 0, 973 }, Exit = { 670, 0, 950 }, },
        { Entrance = { 669, 0, 972 }, Exit = { 670, 0, 949 }, },
        { Entrance = { 669, 0, 971 }, Exit = { 670, 0, 948 }, },
        { Entrance = { 669, 0, 970 }, Exit = { 670, 0, 947 }, },
        { Entrance = { 669, 0, 969 }, Exit = { 670, 0, 946 }, },
        { Entrance = { 669, 0, 968 }, Exit = { 670, 0, 945 }, },
        { Entrance = { 669, 0, 967 }, Exit = { 670, 0, 944 }, },

        { Entrance = { 795, 0, 271 }, Exit = { 796, 0, 285 }, },
        { Entrance = { 795, 0, 270 }, Exit = { 796, 0, 284 }, },
        { Entrance = { 795, 0, 269 }, Exit = { 796, 0, 283 }, },
        { Entrance = { 795, 0, 268 }, Exit = { 796, 0, 282 }, },
        { Entrance = { 795, 0, 267 }, Exit = { 796, 0, 281 }, },
        { Entrance = { 795, 0, 266 }, Exit = { 796, 0, 280 }, },
        { Entrance = { 795, 0, 265 }, Exit = { 796, 0, 279 }, },
        { Entrance = { 795, 0, 264 }, Exit = { 796, 0, 278 }, },
        { Entrance = { 795, 0, 263 }, Exit = { 796, 0, 277 }, },
        { Entrance = { 795, 0, 262 }, Exit = { 796, 0, 276 }, },

    },

    SpawnList = {

        -- small long island northwest corner
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 343 , 13 , 616 },
			Orientation = { 0.0, 100.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 355 , 13 , 594 },
			Orientation = { 0.0, 80.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 374 , 11 , 575 },
			Orientation = { 0.0, 45.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},

        -- large island south and west
		{
			-- creating Mineral Deposit 4
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 513 , 11 , 266 },
			Orientation = { 0.0, 45.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 5
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 460 , 12 , 280 },
			Orientation = { 0.0, -25.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 6
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 483 , 14 , 310 },
			Orientation = { 0.0, -170.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 7
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 447 , 12 , 347 },
			Orientation = { 0.0, -110.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},

        -- northern dry island
		{
			-- creating Mineral Deposit 8
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 629 , 11 , 803 },
			Orientation = { 0.0, 90.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
		{
			-- creating Mineral Deposit 9
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 792 , 13 , 717 },
			Orientation = { 0.0, -45.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},

        -- Volcano
        {
			Prefab = "PREFAB_ARCHIPELAGO_VOLCANO1",
			Position = { 140 , 10 , 562 },
			Orientation = { 0.0, 0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
        {
			Prefab = "PREFAB_ARCHIPELAGO_EMITTER1",
			Position = { 140 , 35 , 562 },
			Orientation = { 0.0, 0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},
        {
			Prefab = "PREFAB_ARCHIPELAGO_EMITTER2",
			Position = { 140 , 35 , 562 },
			Orientation = { 0.0, 0.0 , 0.0},
			PatchBeforeVersion = "1.1.0"
		},

        -- -- Smoke and fire from natural volcano
        -- {
		-- 	Prefab = "PREFAB_ARCHIPELAGO_EMITTER1",
        --     Position = { 576 , 23 , 651 },
		-- 	Orientation = { 0.0, 0.0 , 0.0},
		-- 	PatchBeforeVersion = "1.1.0"
		-- },
        -- {
		-- 	Prefab = "PREFAB_ARCHIPELAGO_EMITTER2",
        --     Position = { 576 , 23 , 651 },
		-- 	Orientation = { 0.0, 0.0 , 0.0},
		-- 	PatchBeforeVersion = "1.1.0"
		-- },


	},

    DensitySpawnList = {

		-- {
		-- 	-- Infertility (farms will never grow crops here)
		-- 	DensityMap = "INFERTILITY_MAP",
		-- 	Density = 1.0,
		-- 	PrefabConfigList = {
		-- 		{
        --             PrefabList = { "PREFAB_BONNERSFERRY_BLANK" },
        --             RandomWeight = 1.0,
        --             OffsetSizeRange = {
        --                 Min = 1.0,
        --                 Max = 1.0
        --             },
        --             OrientationRange = {
        --                 Min = { 0, 0, 0 },
        --                 Max = { 0, 0, 0 }
        --             },
        --             ScaleRange = {
        --                 Min = 1,
        --                 Max = 1
        --             },
        --             ColorRange = {
        --                 Min = { 1, 1, 1, 1 },
        --                 Max = { 1, 1, 1, 1 }
        --             }
        --         }
		-- 	}
		-- },

        {
			-- Trees
			DensityMap = "TREE_MAP_DECIDUOUS",
			Density = 0.9,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TREE_OAK" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 0 },
                        Max = { 1, 1, 1, 0 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TREE_POPLAR" },
                    RandomWeight = 2.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 0 },
                        Max = { 1, 1, 1, 0 },
                    },
                },
				{
                    PrefabList = { "PREFAB_TREE_SYCAMORE" },
                    RandomWeight = 1.0,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 0 },
                        Max = { 1, 1, 1, 0 },
                    },
                },
			}
		},


        {
			-- Trees
			DensityMap = "TREE_MAP_PINE",
			Density = 0.9,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_TREE_PINE" },
                    RandomWeight = 5,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 0.6, 0.7, 0.6, 0 },
                        Max = { 0.6, 0.6, 0.6, 0 },
                    },
                },
			}
		},

        {
			-- Trees
			DensityMap = "TREE_MAP_PALM",
			Density = 0.9,
			PrefabConfigList = {
				{
                    PrefabList = { "PREFAB_DESERT_TREE_PALM1" },
                    RandomWeight = 5,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 1, 1, 1, 1 },
                        Max = { 1, 1, 1, 1 },
                    },
                },
				{
                    PrefabList = { "PREFAB_DESERT_TREE_PALM2" },
                    RandomWeight = 5,
                    OffsetSizeRange = {
                        Min = 0.75,
                        Max = 1.00,
                    },
                    OrientationRange = {
                        Min = { 0, -90, 0 },
                        Max = { 0, 90, 0 },
                    },
                    ScaleRange = {
                        Min = 0.85,
                        Max = 1.15,
                    },
                    ColorRange = {
                        Min = { 0.5, 0.5, 0.5, 0 },
                        Max = { 0.5, 0.5, 0.5, 0 },
                    },
                },
			}
		},

        {
			-- Stone
			DensityMap = "ROCK_MAP",
			Density =0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_ROCK" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
                            Min = 1.10,
                            Max = 1.20,
                        },
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},

        {
			-- Natural springs
			DensityMap = "WELL_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_ARCHIPELAGO_WELL1" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
							Min = 0.75,
							Max = 1.0
					},
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
                            Min = 1.10,
                            Max = 1.20,
                        },
						ColorRange = {
							Min = { 1, 1, 1, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},

        {
			-- Berries
			DensityMap = "BERRIES_MAP",
			Density = 0.90,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_BERRIES" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
                            Min = 0.75,
                            Max = 1.00,
                        },
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},


        {
			-- Fish
			DensityMap = "FISH_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
						PrefabList = { "PREFAB_RESOURCE_FISH" },
						RandomWeight = 0.1,
						OffsetSizeRange = {
                            Min = 0.75,
                            Max = 1.00,
                        },
						OrientationRange = {
							Min = { 0, -180, 0 },
							Max = { 0, 180, 0 }
					},
						ScaleRange = {
							Min = 0.85,
							Max = 1.15
					},
						ColorRange = {
							Min = { 0.8, 0.8, 0.8, 1 },
							Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
	}
})



